diff --git a/shared/gasync/include/gusb.h b/shared/gasync/include/gusb.h
index 336ade2c..fd80638a 100644
--- a/shared/gasync/include/gusb.h
+++ b/shared/gasync/include/gusb.h
@@ -75,16 +75,16 @@ typedef struct {
     struct p_other * others; //nbOthers elements
 } s_usb_descriptors;
 
-typedef struct {
+struct gusb_device {
     unsigned short vendor_id;
     unsigned short product_id;
     char * path;
-    int next;
-} s_usb_dev;
+    struct gusb_device * next;
+};
 
 int gusb_open_ids(unsigned short vendor, unsigned short product);
-s_usb_dev * gusb_enumerate(unsigned short vendor, unsigned short product);
-void gusb_free_enumeration(s_usb_dev * usb_devs);
+struct gusb_device * gusb_enumerate(unsigned short vendor, unsigned short product);
+void gusb_free_enumeration(struct gusb_device * usb_devs);
 int gusb_open_path(const char * path);
 s_usb_descriptors * gusb_get_usb_descriptors(int device);
 int gusb_close(int device);
diff --git a/shared/gasync/src/usb/gusb.c b/shared/gasync/src/usb/gusb.c
index 46d8d497..daf39101 100644
--- a/shared/gasync/src/usb/gusb.c
+++ b/shared/gasync/src/usb/gusb.c
@@ -943,14 +943,14 @@ static int claim_device(int device, libusb_device * dev, struct libusb_device_de
   return 0;
 }
 
-s_usb_dev * gusb_enumerate(unsigned short vendor, unsigned short product) {
+struct gusb_device * gusb_enumerate(unsigned short vendor, unsigned short product) {
 
-  s_usb_dev * usb_devs = NULL;
-  unsigned int nb_usb_devs = 0;
+  struct gusb_device * devs = NULL;
+  struct gusb_device * last = NULL;
 
   int ret = -1;
 
-  static libusb_device** devs = NULL;
+  static libusb_device** usb_devs = NULL;
   static ssize_t cnt = 0;
   int dev_i;
 
@@ -959,7 +959,7 @@ s_usb_dev * gusb_enumerate(unsigned short vendor, unsigned short product) {
     return NULL;
   }
 
-  cnt = libusb_get_device_list(ctx, &devs);
+  cnt = libusb_get_device_list(ctx, &usb_devs);
   if (cnt < 0) {
     PRINT_ERROR_LIBUSB("libusb_get_device_list", cnt)
     return NULL;
@@ -967,7 +967,7 @@ s_usb_dev * gusb_enumerate(unsigned short vendor, unsigned short product) {
 
   for (dev_i = 0; dev_i < cnt; ++dev_i) {
     struct libusb_device_descriptor desc;
-    ret = libusb_get_device_descriptor(devs[dev_i], &desc);
+    ret = libusb_get_device_descriptor(usb_devs[dev_i], &desc);
     if (!ret) {
       if (vendor) {
         if (desc.idVendor != vendor) {
@@ -980,7 +980,7 @@ s_usb_dev * gusb_enumerate(unsigned short vendor, unsigned short product) {
         }
       }
 
-      const char * spath = make_path(devs[dev_i]);
+      const char * spath = make_path(usb_devs[dev_i]);
       if (spath == NULL) {
         continue;
       }
@@ -991,45 +991,44 @@ s_usb_dev * gusb_enumerate(unsigned short vendor, unsigned short product) {
         continue;
       }
 
-      void * ptr = realloc(usb_devs, (nb_usb_devs + 1) * sizeof(*usb_devs));
+      void * ptr = malloc(sizeof(*devs));
       if (ptr == NULL) {
         PRINT_ERROR_ALLOC_FAILED("realloc")
         free(path);
         continue;
       }
 
-      usb_devs = ptr;
+      struct gusb_device * dev = ptr;
 
-      if (nb_usb_devs > 0) {
-        usb_devs[nb_usb_devs - 1].next = 1;
-      }
+      dev->path = path;
+      dev->vendor_id = desc.idVendor;
+      dev->product_id = desc.idProduct;
+      dev->next = NULL;
 
-      usb_devs[nb_usb_devs].path = path;
-      usb_devs[nb_usb_devs].vendor_id = desc.idVendor;
-      usb_devs[nb_usb_devs].product_id = desc.idProduct;
-      usb_devs[nb_usb_devs].next = 0;
+      if (devs == NULL) {
+          devs = dev;
+      } else {
+          last->next = dev;
+      }
 
-      ++nb_usb_devs;
+      last = dev;
     }
   }
 
-  libusb_free_device_list(devs, 1);
+  libusb_free_device_list(usb_devs, 1);
 
-  return usb_devs;
+  return devs;
 }
 
-void gusb_free_enumeration(s_usb_dev * usb_devs) {
-
-  s_usb_dev * current;
-  for (current = usb_devs; current != NULL; ++current) {
+void gusb_free_enumeration(struct gusb_device * devs) {
 
+  struct gusb_device * current = devs;
+  while (current != NULL) {
+    struct gusb_device * next = current->next;
     free(current->path);
-
-    if (current->next == 0) {
-      break;
-    }
+    free(current);
+    current = next;
   }
-  free(usb_devs);
 }
 
 int gusb_open_ids(unsigned short vendor, unsigned short product) {
diff --git a/utils/ds4tool.c b/utils/ds4tool.c
index e49d2d8a..557501df 100644
--- a/utils/ds4tool.c
+++ b/utils/ds4tool.c
@@ -1,5 +1,6 @@
 /*
- * Compile with: gcc -o ds4tool ds4tool.c -lusb-1.0
+ Copyright (c) 2016 Mathieu Laurendeau <mat.lau@laposte.net>
+ License: GPLv3
  */
 
 #include <string.h>
@@ -10,7 +11,8 @@
 #include <gusb.h>
 
 #define VENDOR 0x054c
-#define PRODUCT 0x05c4
+
+static unsigned short products[] = { 0x05c4, 0x09cc };
 
 #define TYPE_DS4 0
 #define TYPE_TEENSY 1
@@ -280,10 +282,21 @@ int main(int argc, char *argv[]) {
 
     read_args(argc, argv);
 
-    s_usb_dev * usb_devs = gusb_enumerate(VENDOR, PRODUCT);
+    struct gusb_device * devs = gusb_enumerate(VENDOR, 0x0000);
+
+    struct gusb_device * current;
+    for (current = devs; current != NULL; current = current->next) {
 
-    s_usb_dev * current;
-    for (current = usb_devs; current != NULL; ++current) {
+        unsigned int i;
+        for (i = 0; i < sizeof(products) / sizeof(*products); ++i) {
+            if (current->product_id == products[i]) {
+                break;
+            }
+        }
+
+        if (i == sizeof(products) / sizeof(*products)) {
+            continue;
+        }
 
         int device = gusb_open_path(current->path);
 
@@ -297,15 +310,10 @@ int main(int argc, char *argv[]) {
                 break;
             }
         }
-
-        if (current->next == 0) {
-            break;
-        }
     }
 
-    gusb_free_enumeration(usb_devs);
+    gusb_free_enumeration(devs);
 
     return ret;
-
 }
 
diff --git a/utils/sixaddr.c b/utils/sixaddr.c
index 84843bfe..d3d30734 100644
--- a/utils/sixaddr.c
+++ b/utils/sixaddr.c
@@ -1,189 +1,129 @@
 /*
- * Derived from sixpair.c version 2007-04-18
- * Updated to work with libusb 1.0.
- *
- * Compile with: gcc -o sixaddr sixaddr.c -lusb-1.0
- *
- * Displays the bdaddr of the PS3 and the bdaddr of the sixaxis.
+ Copyright (c) 2016 Mathieu Laurendeau <mat.lau@laposte.net>
+ License: GPLv3
  */
 
 #include <string.h>
 #include <unistd.h>
 #include <stdio.h>
 #include <stdlib.h>
-#include <libusb-1.0/libusb.h>
 
-#define VENDOR 0x054c
-#define PRODUCT 0x0268
-
-#if !defined(LIBUSB_API_VERSION) && !defined(LIBUSBX_API_VERSION)
-const char * LIBUSB_CALL libusb_strerror(enum libusb_error errcode)
-{
-  return libusb_error_name(errcode);
-}
-#endif
+#include <gusb.h>
 
-static unsigned char msg_master[8];
-static unsigned char msg_slave[18];
+#define VENDOR 0x054c
 
-static const int itfnum = 0;
+static unsigned short products[] = { 0x0268 };
+
+static struct {
+    unsigned char slave[6];
+    unsigned char master[6];
+} out;
+
+int get_bdaddrs(int device) {
+
+    struct {
+        struct usb_ctrlrequest req;
+        unsigned char data[8];
+    } transfer_master = {
+            .req = {
+                    .bRequestType = USB_DIR_IN | USB_TYPE_CLASS | USB_RECIP_INTERFACE,
+                    .bRequest = USB_REQ_CLEAR_FEATURE,
+                    .wValue = 0x03f5,
+                    .wIndex = 0x0000,
+                    .wLength = sizeof(transfer_master.data)
+            }
+    };
+
+    int res = gusb_write_timeout(device, 0, &transfer_master, sizeof(transfer_master.req), 5000);
+
+    if (res > 0) {
+        out.master[0] = transfer_master.data[2];
+        out.master[1] = transfer_master.data[3];
+        out.master[2] = transfer_master.data[4];
+        out.master[3] = transfer_master.data[5];
+        out.master[4] = transfer_master.data[6];
+        out.master[5] = transfer_master.data[7];
+    }
 
-int get_bdaddrs(libusb_device_handle* devh)
-{
-  int res = libusb_control_transfer(devh, LIBUSB_ENDPOINT_IN | LIBUSB_REQUEST_TYPE_CLASS | LIBUSB_RECIPIENT_INTERFACE,
-      LIBUSB_REQUEST_CLEAR_FEATURE, 0x03f5, itfnum, msg_master, sizeof(msg_master), 5000);
+    struct {
+        struct usb_ctrlrequest req;
+        unsigned char data[18];
+    } transfer_slave = {
+            .req = {
+                    .bRequestType = USB_DIR_IN | USB_TYPE_CLASS | USB_RECIP_INTERFACE,
+                    .bRequest = USB_REQ_CLEAR_FEATURE,
+                    .wValue = 0x3f2,
+                    .wIndex = 0x0000,
+                    .wLength = sizeof(transfer_slave.data)
+            }
+    };
+
+    res = gusb_write_timeout(device, 0, &transfer_slave, sizeof(transfer_slave.req), 5000);
+
+    if (res > 0) {
+        out.slave[0] = transfer_slave.data[0];
+        out.slave[1] = transfer_slave.data[1];
+        out.slave[2] = transfer_slave.data[2];
+        out.slave[3] = transfer_slave.data[3];
+        out.slave[4] = transfer_slave.data[4];
+        out.slave[5] = transfer_slave.data[5];
+    }
 
-  if (res < 0)
-  {
-    fprintf(stderr, "Control transfer failed: %s.\n", libusb_strerror(res));
     return res;
-  }
-
-  res = libusb_control_transfer(devh, LIBUSB_ENDPOINT_IN | LIBUSB_REQUEST_TYPE_CLASS | LIBUSB_RECIPIENT_INTERFACE,
-        LIBUSB_REQUEST_CLEAR_FEATURE, 0x3f2, itfnum, msg_slave, sizeof(msg_slave), 5000);
-
-  if (res < 0)
-  {
-    fprintf(stderr, "Control transfer failed: %s.\n", libusb_strerror(res));
-  }
-
-  return res;
 }
 
-int process_device(libusb_device_handle* devh)
-{
-  if(get_bdaddrs(devh) < 0)
-  {
-    return -1;
-  }
+int process_device(int device) {
 
-  printf("Current Bluetooth master: ");
-  printf("%02X:%02X:%02X:%02X:%02X:%02X\n", msg_master[2], msg_master[3], msg_master[4], msg_master[5], msg_master[6], msg_master[7]);
-
-  printf("Current Bluetooth Device Address: ");
-  printf("%02X:%02X:%02X:%02X:%02X:%02X\n", msg_slave[4], msg_slave[5], msg_slave[6], msg_slave[7], msg_slave[8], msg_slave[9]);
-
-  return 0;
-}
-
-int main(int argc, char *argv[])
-{
-  libusb_device** devs;
-  libusb_device_handle* devh = NULL;
-  libusb_context* ctx = NULL;
-  int ret = -1;
-  int i;
-
-  if(libusb_init(&ctx))
-  {
-    fprintf(stderr, "Can't initialize libusb.\n");
-    return -1;
-  }
-
-  //libusb_set_debug(ctx, 128);
-
-  ssize_t cnt = libusb_get_device_list(ctx, &devs);
-
-  if(cnt < 0)
-  {
-    fprintf(stderr, "Can't get USB device list.\n");
-  }
-
-  for(i=0; i<cnt; ++i)
-  {
-    struct libusb_device_descriptor desc;
-    ret = libusb_get_device_descriptor(devs[i], &desc);
-    if(ret < 0)
-    {
-      continue;
+    if (get_bdaddrs(device) < 0) {
+        return -1;
     }
 
-    if(desc.idVendor != VENDOR || desc.idProduct != PRODUCT)
-    {
-      continue;
-    }
+    printf("Current Bluetooth master: ");
+    printf("%02X:%02X:%02X:%02X:%02X:%02X\n", out.master[0], out.master[1], out.master[2], out.master[3], out.master[4], out.master[5]);
 
-    ret = libusb_open(devs[i], &devh);
-    if(ret < 0)
-    {
-      continue;
-    }
+    printf("Current Bluetooth Device Address: ");
+    printf("%02X:%02X:%02X:%02X:%02X:%02X\n", out.slave[0], out.slave[1], out.slave[2], out.slave[3], out.slave[4], out.slave[5]);
 
-#if defined(LIBUSB_API_VERSION) || defined(LIBUSBX_API_VERSION)
-    libusb_set_auto_detach_kernel_driver(devh, 1);
-#else
-#ifndef WIN32
-    ret = libusb_kernel_driver_active(devh, 0);
-    if(ret > 0)
-    {
-      ret = libusb_detach_kernel_driver(devh, 0);
-      if(ret < 0)
-      {
-        fprintf(stderr, "Can't detach kernel driver: %s.\n", libusb_strerror(ret));
-        continue;
-      }
-    }
-#endif
-#endif
+    return 0;
+}
 
-    int config;
+int main(int argc, char *argv[]) {
 
-    ret = libusb_get_configuration(devh, &config);
-    if(ret != LIBUSB_SUCCESS)
-    {
-      fprintf(stderr, "Can't get configuration: %s.\n", libusb_strerror(ret));
-      continue;
-    }
+    int ret = 0;
+    int status;
 
-    if(config != 1)
-    {
-      ret = libusb_set_configuration(devh, 1);
-      if(ret != LIBUSB_SUCCESS)
-      {
-        fprintf(stderr, "Can't set configuration: %s.\n", libusb_strerror(ret));
-        continue;
-      }
-    }
+    struct gusb_device * devs = gusb_enumerate(VENDOR, 0x0000);
 
-    ret = libusb_claim_interface(devh, 0);
-    if(ret < 0)
-    {
-      fprintf(stderr, "Can't claim interface: %s.\n", libusb_strerror(ret));
-      continue;
-    }
+    struct gusb_device * current;
+    for (current = devs; current != NULL; current = current->next) {
 
-    ret = process_device(devh);
+        unsigned int i;
+        for (i = 0; i < sizeof(products) / sizeof(*products); ++i) {
+            if (current->product_id == products[i]) {
+                break;
+            }
+        }
 
-    ret = libusb_release_interface(devh, 0);
-    if(ret < 0)
-    {
-      fprintf(stderr, "Can't release interface: %s.\n", libusb_strerror(ret));
-    }
+        if (i == sizeof(products) / sizeof(*products)) {
+            continue;
+        }
 
-#if !defined(LIBUSB_API_VERSION) && !defined(LIBUSBX_API_VERSION)
-#ifndef WIN32
-    ret = libusb_attach_kernel_driver(devh, 0);
-    if(ret < 0)
-    {
-      fprintf(stderr, "Can't attach kernel driver: %s.\n", libusb_strerror(ret));
-    }
-#endif
-#endif
+        int device = gusb_open_path(current->path);
 
-    libusb_close(devh);
-    devh = NULL;
-  }
+        if (device >= 0) {
 
-  if(devh != NULL)
-  {
-    libusb_close(devh);
-  }
+            status = process_device(device);
 
-  libusb_free_device_list(devs, 1);
+            gusb_close(device);
 
-  libusb_exit(ctx);
+            if (status == 0) {
+                break;
+            }
+        }
+    }
 
-  return ret;
+    gusb_free_enumeration(devs);
 
+    return ret;
 }
 
